require "base64"
require "digest"

class Payment
	@vad_number
	@secret_key
	@urlRetourOK
	@urlRetourNOK
	@urlIPN
	@typeTr

	def initialize(vad_number = "", secret_key = "", urlRetourOK = "", urlRetourNOK = "", urlIPN = "", source="", typeTr="D")
		@vad_number = vad_number
		@secret_key = secret_key
		@urlRetourOK = urlRetourOK
		@urlRetourNOK = urlRetourNOK
		@urlIPN = urlIPN
		@source = source
		@typeTr = typeTr
	end

	def buildSecretHTML(produit="Produit", montant="0.00", idTransaction="")

		if idTransaction == ""
			@idTransaction = Time.now.to_i.to_s+"-"+@vad_number+"-"+(0...3).map { ('a'..'z').to_a[rand(26)] }.join #time().$this->vad_number.sprintf("%03d",rand(0,999))
		else
			@idTransaction = idTransaction
		end

		array_tpe	= {
				"montant"=>montant.to_s,
				'idTPE' => @vad_number,
				'idTransaction' => @idTransaction,
				'devise' => "EUR",
				'lang' => 'fr',
				'nom_produit' => produit,
				'source' => @source,
				'urlRetourOK' => @urlRetourOK,
				'urlRetourNOK' => @urlRetourNOK,
				'typeTr'		=> @typeTr.to_s
		}

		if @urlIPN!=""
			array_tpe['urlIPN'] = @urlIPN;
		end

		array_tpe['key'] = @secret_key;
		strWithKey = Base64.encode64(array_tpe.map{|k,v| "#{v}"}.join('|')).gsub(/\n/, '')
		array_tpe.delete("key")
		array_tpe['sec'] = Digest::SHA512.hexdigest(strWithKey)

		ret = ""
		for k,v in array_tpe
			ret += '<input type="hidden" name="'+k+'" value="'+v+'"/>'
		end

		return ret
	end
	
	def validSec(values, secret_key)
		if values.has_key?("sec")
			sec = values['sec']
			values.delete("sec")
			return Digest::SHA512.hexdigest(Base64.encode64(values.map{|k,v| "#{v}"}.join('|')+"|"+secret_key)).upcase == sec.upcase
		else
			return false
		end
	end
end